/// @addtogroup homologicalAlgebra
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file homologicalAlgebra.h
///
/// @author Marian Mrozek
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2006 by the CAPD Group.
//
// This file constitutes a part of the CAPD library, 
// distributed under the terms of the GNU General Public License.
// Consult  http://capd.wsb-nlu.edu.pl/ for details. 

#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <iterator>
#include <sstream>

#include "capd/matrixAlgorithms/intMatrixAlgorithms.hpp"
#include "capd/repSet/ElementaryCube.h"
#include "capd/repSet/ElementaryCell.h"
#include "capd/repSet/RepSet.h"
using namespace chomp::matrixAlgorithms;

#include "capd/homologicalAlgebra/FreeModule.h"
#include "capd/homologicalAlgebra/ChainAux.h"
#include "capd/homologicalAlgebra/SubModule.h"
#include "capd/homologicalAlgebra/QuotientModule.h"
#include "capd/homologicalAlgebra/FreeModuleHomomorphism.h"
#include "capd/homologicalAlgebra/FreeChainComplex.h"
#include "capd/homologicalAlgebra/QuotientGradedModule.h"
#include "capd/homologicalAlgebra/ReducibleFreeChainComplex.h"
//#include "homologicalAlgebra/ReducibleFreeChainComplex.hpp"











/// @}

